/**
 * $RCSfile$
 * version $Revision$
 * created 07.06.2008 11:32:39 by kunina
 * last modified $Date$ by $Author$
 * (C) ООО Крипто-Про 2004-2008.
 *
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован 
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package Applet_samples.AppletNew;

import ru.CryptoPro.JCP.tools.Array;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.security.cert.Certificate;
import java.util.List;

/**
 * Main Panel..
 *
 * @author Copyright 2004-2008 Crypto-Pro. All rights reserved.
 * @.Version
 */

public class MainPane {
private JPanel page;
private JTabbedPane tabbedPane;
private JTextPane chSignKeyTextPane;
private JTextField keyTextField;
private JButton chKeyBut;
private JTextField fileTextField;
private JButton chFileBut;
private JTextPane chFileTextPane;
private JButton signatureButton;
private JComboBox modeCBox;
private JTextPane keyTextPane;
private JTextField keyCrTextField;
private JButton keyButton;
private JButton encryptButton;
private JComboBox CBox;
private JTextPane fileTextPane;
private JTextField fileCrTextField;
private JButton fileButton;
private JTextPane certTextPane;
private JTextField certCrTextField;
private JButton certButton;
private JTextPane infoTextPane;
private JTextPane helpTextPane;
private JComboBox signModeCBox;
private JPanel tabSign;
private JPanel signaturePane;
private JPanel infoPane;
private JPanel tabEncr;
private JPanel encryptPane;
private JPanel tabHelp;
private Image ico;
private boolean isENCRYPT;
private GridBagConstraints gbc;

 /**/
public MainPane() {
    setupUI();
    ico = new ImageIcon(getClass().getResource("ico.png")).getImage();
    //background
    chSignKeyTextPane.setBackground(page.getBackground());
    chFileTextPane.setBackground(page.getBackground());
    keyTextPane.setBackground(page.getBackground());
    fileTextPane.setBackground(page.getBackground());
    certTextPane.setBackground(page.getBackground());
    infoTextPane.setBackground(page.getBackground());
    helpTextPane.setBackground(page.getBackground());
    CBox.setBackground(page.getBackground());
    //help
    InputStream is = null;
    String help;
    try {
        is = getClass().getResource("help.txt").openStream();
        final byte[] helpBytes = new byte[is.available()];
        int total = 0;
        int len;
        do {
            len = is.read(helpBytes, total, helpBytes.length - total);
            total += len;
        } while (len > 0);
        help = new String(helpBytes);
    } catch (IOException e) {
        help = e.toString();
    }
    finally {
        if (is != null)
            try {
                is.close();
            } catch (IOException e) {
                //
            }
    }
    helpTextPane.setText(help);
    //actions
    tabbedPane.addChangeListener(new ChangeListener() {
        public void stateChanged(ChangeEvent e) {
            clean();
        }
    });
    //tab Signature
    signModeCBox.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            if (signModeCBox.getSelectedIndex() == 0) {
                clean();
                chSignKeyTextPane.setText("Choose a signature key");
                signatureButton.setText("Generate signature");
            } else if (signModeCBox.getSelectedIndex() == 1) {
                clean();
                chSignKeyTextPane.setText("Choose a certificate");
                signatureButton.setText("Verify signature");
            }
        }
    });
    chKeyBut.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            if (signModeCBox.getSelectedIndex() == 0) {
                final JCPKeyPane kp = new JCPKeyPane("Keys", ico,
                        getRootComponent(), false, keyTextField);
                kp.pack();
                kp.show();
            } else if (signModeCBox.getSelectedIndex() == 1) {
                final List ret = Processor
                        .genCertFromFile(getFile("getCert", ico, keyTextField));
                final String err = (String) ret.get(0);
                if (err == null) {
                    Processor.setCert((Certificate) ret.get(1));
                } else {
                    JOptionPane.showMessageDialog(page, new String[]{err},
                            "Error", JOptionPane.ERROR_MESSAGE);
                    keyTextField.setText("");
                }
            }
        }
    });
    chFileBut.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            Processor.setFile(getFile("Open", ico, fileTextField));
        }
    });
    signatureButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            if (signModeCBox.getSelectedIndex() == 0) {
                if (Processor.getKeyAlias() == null)
                    JOptionPane.showMessageDialog(page,
                            new String[]{"Key not choosed"}, "Error",
                            JOptionPane.ERROR_MESSAGE);
                else if (!Processor.isSetFile()) {
                    JOptionPane.showMessageDialog(page,
                            new String[]{"File not choosed"}, "Error",
                            JOptionPane.ERROR_MESSAGE);
                } else {
                    final File fileToSave = getFile("Save", ico, null);
                    if (fileToSave.exists()) {
                        if (JOptionPane.showConfirmDialog(page, new String[]{
                                "File already exist", "Replace it?"},
                                "Removing", JOptionPane.YES_NO_OPTION,
                                JOptionPane.INFORMATION_MESSAGE) == JOptionPane
                                .YES_OPTION)
                            signAndWrite(fileToSave);
                    } else {
                        signAndWrite(fileToSave);
                    }
                }
            } else if (signModeCBox.getSelectedIndex() == 1)
                if (!Processor.isSetCert())
                    JOptionPane.showMessageDialog(page, new String[]{
                            "Certificate not choosed"
                    }, "Error", JOptionPane.ERROR_MESSAGE);
                else if (!Processor.isSetFile()) {
                    JOptionPane.showMessageDialog(page, new String[]{
                            "File not choosed"
                    }, "Error", JOptionPane.ERROR_MESSAGE);
                } else {
                    final File fileWithSign = getFile("getSignFile", ico, null);
                    final List ret = Processor.signVerify(fileWithSign);
                    final String err = (String) ret.get(0);
                    if (err == null) {
                        if ("true".equals(ret.get(1)))
                            JOptionPane.showMessageDialog(page,
                                    new String[]{"The signature is true"},
                                    "Info", JOptionPane.INFORMATION_MESSAGE);
                        else
                            JOptionPane.showMessageDialog(page,
                                    new String[]{"The signature is not true"},
                                    "Info", JOptionPane.INFORMATION_MESSAGE);
                    } else {
                        JOptionPane.showMessageDialog(page, new String[]{err},
                                "Error", JOptionPane.ERROR_MESSAGE);
                    }
                }
        }
    });
    //tab Encryption
    keyButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            final JCPKeyPane kp =
                    new JCPKeyPane("Keys", ico, getRootComponent(),
                            false, keyCrTextField);
            kp.pack();
            kp.show();
        }
    });
    fileButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            Processor.setFile(getFile("Open", ico, fileCrTextField));
        }
    });
    certButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            final List ret = Processor
                    .genCertFromFile(getFile("getCert", ico, certCrTextField));
            final String err = (String) ret.get(0);
            if (err == null) {
                Processor.setCert((Certificate) ret.get(1));
            } else {
                JOptionPane.showMessageDialog(page, new String[]{err}, "Error",
                        JOptionPane.ERROR_MESSAGE);
                certCrTextField.setText("");
            }
        }
    });
    CBox.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            if (((String) CBox.getSelectedItem()).indexOf("encrypt") != -1) {
                isENCRYPT = true;
                encryptButton.setText("Encrypt");
                fileTextPane.setText("Choose file for encryption");
            } else
            if (((String) CBox.getSelectedItem()).indexOf("decrypt") != -1) {
                isENCRYPT = false;
                encryptButton.setText("Decrypt");
                fileTextPane.setText("Choose file for decryption");
            }
        }
    });
    encryptButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            if (CBox.getSelectedIndex() == 0)
                JOptionPane.showMessageDialog(page,
                        new String[]{"Encyption variant not choosed"}, "Error",
                        JOptionPane.ERROR_MESSAGE);
            else if (modeCBox.getSelectedIndex() == 0)
                JOptionPane.showMessageDialog(page,
                        new String[]{"Encyption mode not choosed"}, "Error",
                        JOptionPane.ERROR_MESSAGE);
            else if (Processor.getKeyAlias() == null)
                JOptionPane.showMessageDialog(page,
                        new String[]{"Key not choosed"}, "Error",
                        JOptionPane.ERROR_MESSAGE);
            else if (!Processor.isSetFile()) {
                JOptionPane.showMessageDialog(page,
                        new String[]{"File not choosed"}, "Error",
                        JOptionPane.ERROR_MESSAGE);
            } else {
                final File fileToSave = getFile("Save", ico, null);
                if (fileToSave.exists()) {
                    if (JOptionPane.showConfirmDialog(page,
                            new String[]{"File already exist", "Replace it?"},
                            "Removing", JOptionPane.YES_NO_OPTION,
                            JOptionPane.INFORMATION_MESSAGE) == JOptionPane
                            .YES_OPTION)
                        cryptAndWrite(fileToSave);
                } else if (fileToSave.getName() != null)
                    cryptAndWrite(fileToSave);
            }
        }
    });
}

/**
 * clean
 */
private void clean() {
    Processor.cleanAll();
    keyTextField.setText("");
    fileTextField.setText("");
    keyCrTextField.setText("");
    fileCrTextField.setText("");
    modeCBox.setSelectedIndex(0);
    CBox.setSelectedIndex(0);
}

/**
 * Шифрование
 *
 * @param fileToSave файл для сохранений результата
 */
private void cryptAndWrite(File fileToSave) {
    final String mod;
    if (isENCRYPT)
        mod = "ENCRYPTION";
    else
        mod = "DECRYPTION";
    try {
        final List ret =
                Processor.crypt((String) modeCBox.getSelectedItem(), isENCRYPT);
        final String err = (String) ret.get(0);
        if (err == null) {
            Array.writeFile(fileToSave, (byte[]) ret.get(1));
            JOptionPane.showMessageDialog(page, new String[]{mod,
                    "Text was writing successfully", fileToSave.getPath()},
                    "Info", JOptionPane.INFORMATION_MESSAGE);
        } else {
            JOptionPane.showMessageDialog(page, new String[]{err}, "Error",
                    JOptionPane.ERROR_MESSAGE);
        }
    }
    catch (IOException e) {
        e.printStackTrace();
    }
}

/**
 * Подпись и запись ее в файл
 *
 * @param fileToSave файл для сохранения подписи
 */
private void signAndWrite(File fileToSave) {
    try {
        final List ret = Processor.sign();
        final String err = (String) ret.get(0);
        if (err == null) {
            Array.writeFile(fileToSave, (byte[]) ret.get(1));
            JOptionPane.showMessageDialog(page, new String[]{
                    "Signature was writing successfully", fileToSave.getPath()},
                    "Info", JOptionPane.INFORMATION_MESSAGE);
        } else {
            JOptionPane.showMessageDialog(page, new String[]{err}, "Error",
                    JOptionPane.ERROR_MESSAGE);
        }
    }
    catch (IOException e) {
        e.printStackTrace();
    }
}

/**
 * Получение файла
 *
 * @param option open/save
 * @param field textfield
 * @param icon icon
 * @return file
 */
private static File getFile(String option, Image icon, JTextField field) {
    final JFileChooser chooser = new JFileChooser();
    final JFrame frame = new JFrame();
    frame.setTitle(option);
    frame.setIconImage(icon);
    chooser.setFileSelectionMode(0);
    chooser.setMultiSelectionEnabled(false);
    final int retval = chooser.showDialog(frame, option);
    File selected = null;
    if (retval == 0)
        selected = chooser.getSelectedFile();
    if (selected != null && field != null)
        field.setText(selected.getPath());
    return selected;
}

/**
 * Получение панели с элементами
 *
 * @return панель
 */
public JComponent getRootComponent() {
    return page;
}

/**
 * Графический интерфейс
 */
private void setupUI() {
    page = new JPanel();
    page.setLayout(new GridBagLayout());
    tabbedPane = new JTabbedPane();
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridwidth = 2;
    gbc.fill = 1;
    page.add(tabbedPane, gbc);
    tabSign = new JPanel();
    tabSign.setLayout(new BorderLayout(0, 0));
    tabbedPane.addTab("Signature", null, tabSign, null);
    signatureButton = new JButton();
    signatureButton.setVerticalAlignment(0);
    signatureButton.setText("Generate signature");
    tabSign.add(signatureButton, "South");
    signaturePane = new JPanel();
    signaturePane.setLayout(new GridBagLayout());
    tabSign.add(signaturePane, "Center");
    chSignKeyTextPane = new JTextPane();
    chSignKeyTextPane.setText("Choose a signature key");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.gridwidth = 3;
    gbc.fill = 1;
    gbc.insets = new Insets(5, 5, 0, 5);
    signaturePane.add(chSignKeyTextPane, gbc);
    keyTextField = new JTextField();
    gbc = new GridBagConstraints();
    gbc.gridx = 1;
    gbc.gridy = 3;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.ipadx = 200;
    gbc.insets = new Insets(0, 5, 5, 0);
    signaturePane.add(keyTextField, gbc);
    chKeyBut = new JButton();
    chKeyBut.setText("...");
    gbc = new GridBagConstraints();
    gbc.gridx = 2;
    gbc.gridy = 3;
    gbc.fill = 2;
    gbc.insets = new Insets(0, 0, 5, 5);
    signaturePane.add(chKeyBut, gbc);
    chFileTextPane = new JTextPane();
    chFileTextPane.setText("Choose a file ");
    gbc = new GridBagConstraints();
    gbc.gridx = 1;
    gbc.gridy = 4;
    gbc.gridwidth = 2;
    gbc.fill = 1;
    gbc.insets = new Insets(0, 5, 0, 5);
    signaturePane.add(chFileTextPane, gbc);
    fileTextField = new JTextField();
    gbc = new GridBagConstraints();
    gbc.gridx = 1;
    gbc.gridy = 5;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.ipadx = 200;
    gbc.insets = new Insets(0, 5, 5, 0);
    signaturePane.add(fileTextField, gbc);
    chFileBut = new JButton();
    chFileBut.setText("...");
    gbc = new GridBagConstraints();
    gbc.gridx = 2;
    gbc.gridy = 5;
    gbc.fill = 2;
    gbc.insets = new Insets(0, 0, 5, 5);
    signaturePane.add(chFileBut, gbc);
    infoPane = new JPanel();
    infoPane.setLayout(new GridBagLayout());
    gbc = new GridBagConstraints();
    gbc.gridx = 1;
    gbc.gridy = 0;
    gbc.gridwidth = 2;
    gbc.fill = 1;
    gbc.insets = new Insets(5, 5, 5, 5);
    signaturePane.add(infoPane, gbc);
    infoPane.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), null, 0, 0, null, null));
    infoTextPane = new JTextPane();
    infoTextPane.setText("This is applet sample." + "\n" +
            "You can work with signature (\"Signature\" pane)" + "\n" +
            "and encrypt/decrypt text (\"Encryption\" pane)");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridwidth = 2;
    gbc.fill = 1;
    infoPane.add(infoTextPane, gbc);
    signModeCBox = new JComboBox();
    final DefaultComboBoxModel signModeCBoxModel = new DefaultComboBoxModel();
    signModeCBoxModel.addElement("signature generation");
    signModeCBoxModel.addElement("signature verification");
    signModeCBox.setModel(signModeCBoxModel);
    gbc = new GridBagConstraints();
    gbc.gridx = 1;
    gbc.gridy = 1;
    gbc.gridwidth = 2;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.insets = new Insets(5, 5, 5, 5);
    signaturePane.add(signModeCBox, gbc);
    tabEncr = new JPanel();
    tabEncr.setLayout(new BorderLayout(0, 0));
    tabbedPane.addTab("Encryption", null, tabEncr, null);
    encryptButton = new JButton();
    encryptButton.setText("Encrypt");
    tabEncr.add(encryptButton, "South");
    encryptPane = new JPanel();
    encryptPane.setLayout(new GridBagLayout());
    tabEncr.add(encryptPane, "Center");
    CBox = new JComboBox();
    final DefaultComboBoxModel CBoxModel = new DefaultComboBoxModel();
    CBoxModel.addElement("choose variant");
    CBoxModel.addElement("Classic encrypt");
    CBoxModel.addElement("Classic decrypt");
    CBox.setModel(CBoxModel);
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridwidth = 3;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.insets = new Insets(5, 5, 5, 5);
    encryptPane.add(CBox, gbc);
    modeCBox = new JComboBox();
    final DefaultComboBoxModel modeCBoxModel = new DefaultComboBoxModel();
    modeCBoxModel.addElement("choose mode");
    modeCBoxModel.addElement("GOST28147/CFB/NoPadding");
    modeCBoxModel.addElement("GOST28147/CNT/NoPadding");
    modeCBoxModel.addElement("GOST28147/CBC/NoPadding");
    modeCBoxModel.addElement("GOST28147/CBC/PKCS5_PADDING");
    modeCBoxModel.addElement("GOST28147/ECB/NoPadding");
    modeCBoxModel.addElement("GOST28147/ECB/PKCS5_PADDING");
    modeCBox.setModel(modeCBoxModel);
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.gridwidth = 3;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.insets = new Insets(5, 5, 5, 5);
    encryptPane.add(modeCBox, gbc);
    keyTextPane = new JTextPane();
    keyTextPane.setText("Choose key");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.gridwidth = 3;
    gbc.fill = 1;
    gbc.insets = new Insets(0, 5, 0, 5);
    encryptPane.add(keyTextPane, gbc);
    keyCrTextField = new JTextField();
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 3;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.ipadx = 200;
    gbc.insets = new Insets(0, 5, 5, 0);
    encryptPane.add(keyCrTextField, gbc);
    keyButton = new JButton();
    keyButton.setText("...");
    gbc = new GridBagConstraints();
    gbc.gridx = 2;
    gbc.gridy = 3;
    gbc.fill = 2;
    gbc.insets = new Insets(0, 0, 5, 5);
    encryptPane.add(keyButton, gbc);
    fileTextPane = new JTextPane();
    fileTextPane.setText("Choose file");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 6;
    gbc.gridwidth = 3;
    gbc.fill = 1;
    gbc.insets = new Insets(0, 5, 0, 5);
    encryptPane.add(fileTextPane, gbc);
    fileCrTextField = new JTextField();
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 7;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.insets = new Insets(0, 5, 5, 0);
    encryptPane.add(fileCrTextField, gbc);
    fileButton = new JButton();
    fileButton = fileButton;
    fileButton.setText("...");
    gbc = new GridBagConstraints();
    gbc.gridx = 2;
    gbc.gridy = 7;
    gbc.fill = 2;
    gbc.insets = new Insets(0, 0, 5, 5);
    encryptPane.add(fileButton, gbc);
    certTextPane = new JTextPane();
    certTextPane.setText("Choose certificate");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 4;
    gbc.gridwidth = 3;
    gbc.fill = 1;
    gbc.insets = new Insets(0, 5, 0, 5);
    encryptPane.add(certTextPane, gbc);
    certCrTextField = new JTextField();
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 5;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.ipadx = 200;
    gbc.insets = new Insets(0, 5, 5, 0);
    encryptPane.add(certCrTextField, gbc);
    certButton = new JButton();
    certButton.setText("...");
    gbc = new GridBagConstraints();
    gbc.gridx = 2;
    gbc.gridy = 5;
    gbc.fill = 2;
    gbc.insets = new Insets(0, 0, 5, 5);
    encryptPane.add(certButton, gbc);
    tabHelp = new JPanel();
    tabHelp.setLayout(new GridBagLayout());
    tabbedPane.addTab("Help", null, tabHelp, null);
    helpTextPane = new JTextPane();
    helpTextPane.setText("help");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.fill = 3;
    tabHelp.add(helpTextPane, gbc);
}
}