/**
 * $RCSfile$
 * version $Revision$
 * created 04.07.2007 14:31:39 by kunina
 * last modified $Date$ by $Author$
 * (C) ООО Крипто-Про 2004-2007.
 *
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован 
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package ComLine;

import ru.CryptoPro.JCP.JCP;

import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.Provider;
import java.security.Security;
import java.util.logging.Logger;

/**
 * Проверка установки и настроек провайдеров.
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class CheckConf {
/**
 * logger
 */
private static Logger log = Logger.getLogger("LOGGER");

/**
 *
 */
private CheckConf() {
}

/**
 * CheckConf (без параметров)
 *
 * @param args без параметров
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    if (ComLine.getFunc(ComLine.hllp, args))
        log.info(ComLine.HCheckConf + "   (without parameters)");
    else
        check();
}

/**
 * Проверка установки компонентов
 *
 * @throws Exception ошибки
 */
private static void check() throws Exception {
    //Проверка правильности установки провайдеров
    final Provider[] provs = Security.getProviders();
    int flag_jcp = 0;
    int flag_crypto = 0;
    int flag_jtls = 0;
    String s = "";
    for (int i = 0; i < provs.length; i++) {
        //System.out.println(provs[i].getName());
        if ("JCP".equals(provs[i].getName()))
            flag_jcp = 1;
        if ("Crypto".equals(provs[i].getName()))
            flag_crypto |= 1;
        if ("JTLS".equals(provs[i].getName()))
            flag_jtls |= 1;
    }
    if (flag_jcp != 1) s = s + "Провайдер не установлен.\n";
    if (flag_crypto != 1) s = s + "Провайдер Crypto не установлен\n";
    if (flag_jtls != 1) s = s + "Провайдер JTLS не установлен\n";
    if (s.length() > 0) log.info(s + "\n\nПроверка настроек:\n");
    else log.info(
            "Провайдеры JCP,Crypto,JTLS установлены\n\nПроверка настроек:\n");
    // проверка правильности работы JCP
    final String[] sout = new String[3];
    int i = 0;
    try {
        final java.security.Signature sig =
                java.security.Signature.getInstance("GOST3411withGOST3410EL");
        sout[i] = "Провайдер JCP настроен верно";
        i++;
    } catch (NoSuchAlgorithmException e) {
        sout[i] = "Провайдер JCP не установлен.";
        i++;
    }
    // проверка правильности работы Crypto
    try {
        final KeyPairGenerator keyGen =
                KeyPairGenerator.getInstance(JCP.GOST_EL_DH_EPH_NAME);
        sout[i] = "Провайдер Crypto настроен верно";
        i++;
    } catch (NoSuchAlgorithmException e) {
        sout[i] = "Провайдер Crypto не установлен.";
        i++;
    }
    // проверка правильности настроек TLS
    int j = 0;
    String[] sout1 = new String[4];
    final String factoryProvider =
            Security.getProperty("ssl.SocketFactory.provider");
    if (factoryProvider == null ||
            !factoryProvider.equals("ru.CryptoPro.ssl.SSLSocketFactoryImpl")) {
        sout1[j] =
                "Неверное значение ssl.SocketFactory.provider в java.security";
        j++;
    }
    final String serverProvider = Security
            .getProperty("ssl.ServerSocketFactory.provider");
    if (serverProvider == null || !serverProvider
            .equals("ru.CryptoPro.ssl.SSLServerSocketFactoryImpl")) {
        sout1[j] =
                "Неверное значение ssl.ServerSocketFactory.provider в java.security";
        j++;
    }
    final String keyManager = Security
            .getProperty("ssl.KeyManagerFactory.algorithm");
    if (keyManager == null || !keyManager.equals("GostX509")) {
        sout1[j] =
                "Неверное значение ssl.KeyManagerFactory.algorithm в java.security";
        j++;
    }
    final String trust = Security
            .getProperty("ssl.TrustManagerFactory.algorithm");
    if (trust == null || !trust.equals("GostX509")) {
        sout1[j] =
                "Неверное значение ssl.TrustManagerFactory.algorithm в java.security";
        j++;
    }

    final int jmax = j - 1;
    if (j == 0) {
        sout[i] = "Провайдер JTLS настроен верно";
        i++;
    } else {
        String ss = "";
        for (int jj = 0; jj <= jmax; jj++) {
            ss = ss + "\n" + sout1[jj];
        }
        sout[i] = "Провайдер JTLS настроен неверно:" + ss;
        i++;
    }


    final int imax = i - 1;
    String Sout = "\n" + sout[0];
    for (i = 1; i <= imax; i++) {
        Sout = Sout + "\n" + sout[i];
    }
    log.info(Sout + "\n");
}
}
