/**
 * $RCSfile$
 * version $Revision$
 * created 26.06.2007 14:59:43 by kunina
 * last modified $Date$ by $Author$
 * (C) ООО Крипто-Про 2004-2007.
 *
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован 
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package ComLine;

import ru.CryptoPro.JCPRequest.GostCertificateRequest;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.KeyStore;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.util.Properties;
import java.util.logging.Logger;

/**
 * Получение сертификата из запроса, представленного в DER-кодировке и запись
 * его в хранилище и в файл
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class getCert {
/**
 * logger
 */
private static Logger log = Logger.getLogger("LOGGER");

/**
 * forbidden
 */
private getCert() {
}

/**
 * getCert -alias name_of_key [-storetype HDImageStore] [-storepath null]
 * [-storepass null] -http http://www.cryptopro.ru/certsrv/ -certpath C:/*.cer
 * -reqCertpath C:/*.*
 * <p/>
 * <DL> <DT><b> -alias </b>  <DD>уникальное имя ключа</DD> <DT><b> -storetype
 * </b> <DD>имя ключевого носителя HDImageStore (жесткий диск), FloppyStore
 * (дискета), OCFStore или J6CFStore (карточки), RutokenStore (Рутокен)<DD>(по умолчанию
 * HDImageStore)</DD> <DT><b>-storepath </b> <DD>путь к хранилищу доверенных
 * сертификатов <DD>(по умолчанию null)</DD> <DT><b> -storepass </b> <DD>пароль
 * на хранилище доверенных сертификатов <DD>(по умолчанию null)</DD> <DT><b>
 * -http </b> <DD>путь к центру сертификации</DD> <DT><b> -reqCertpath</b>
 * <DD>путь к файлу с запросом</DD> <DT><b> -encoding</b>  <DD>кодировка запроса
 * (DER/BASE64)<DD>(по умочанию DER)</DD> <DT><b> -сertpath</b> <DD>путь к файлу
 * для записи сертификата</DD></DT> </DL>
 *
 * @param args аргументы командной строки
 */
public static void main(String[] args) {
    if (ComLine.getFunc(ComLine.hllp, args)) log.info(ComLine.CertsHelpHD);
    else
        try {
            //Заполнение таблицы свойств значениями параметров командной строки
            //или значениями по умолчанию при отсутствии первых
            final Properties ArgList = new Properties();
            //уникальное имя ключа
            ArgList.setProperty(ComLine.ALIAS,
                    ComLine.getValue(ComLine.ALIAS, args, null));
            //тип ключевого носителя
            ArgList.setProperty(ComLine.storetype,
                    ComLine.getValue(ComLine.storetype, args,
                            ComLine.HDImageStore));
            //путь к хранилищу доверенных сертификатов
            ArgList.setProperty(ComLine.storepath,
                    ComLine.getValue(ComLine.storepath, args, "null"));
            //пароль на хранилище доверенных сертификатов
            ArgList.setProperty(ComLine.storepass,
                    ComLine.getValue(ComLine.storepass, args, "null"));
            //путь к центру сертификации
            ArgList.setProperty(ComLine.http,
                    ComLine.getValue(ComLine.http, args, null));
            //путь к запросу на сертификат
            ArgList.setProperty(ComLine.reqCertpath,
                    ComLine.getValue(ComLine.reqCertpath, args, null));
            //путь к файлу для записи сертификата
            ArgList.setProperty(ComLine.certpath,
                    ComLine.getValue(ComLine.certpath, args, null));
            //кодировка запроса
            ArgList.setProperty(ComLine.encoding,
                    ComLine.getValue(ComLine.encoding, args, "der"));

            //Проверка типа хранилища.
            //При неверном вводе присваивается значение по умолчанию HDImageStore.
            final String ks;
            ks = ArgList.getProperty(ComLine.storetype);
            if (ks.equalsIgnoreCase(ComLine.HDImageStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.FloppyStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.OCFStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.RTStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.J6CFStore)) {
            } else {
                ArgList.setProperty(ComLine.storetype, ComLine.HDImageStore);
                log.info("Incorrect keystore type: " + ks +
                        ". Value by default is appropriated: " + ComLine
                        .HDImageStore);
            }

            //Запрос сертификата и его запись
            getCert(
                    ArgList.getProperty(ComLine.ALIAS),
                    ArgList.getProperty(ComLine.reqCertpath),
                    ArgList.getProperty(ComLine.storetype),
                    ArgList.getProperty(ComLine.storepass),
                    ArgList.getProperty(ComLine.storepath),
                    ArgList.getProperty(ComLine.http),
                    ArgList.getProperty(ComLine.certpath),
                    ArgList.getProperty(ComLine.encoding));

        } catch (NullPointerException e) {
            //System.out.println(e.toString());
            log.info(ComLine.GetCertHelpHD);
        } catch (Exception e1) {
            final String sss = "java.lang.Exception:";
            log.info("\n" +
                    e1.toString()
                            .substring(sss.length(), e1.toString().length()) +
                    "\n" + ComLine.GetCertHelpHD);
        }

}

/**
 * @param alias имя ключа
 * @param reqpath путь к файлу с запросом
 * @param keystoreName тип ключевого носителя
 * @param keystorePass пароль на хранилище доверенных сертификатов
 * @param keystorePath путь к хранилищу доверенных сертификатов
 * @param httpAddr путь к центру сертификации
 * @param cerpath путь к файлу для записи сертификата
 * @param encoding кодировка запроса
 * @throws Exception ...
 */
private static void getCert(String alias,
                            String reqpath,
                            String keystoreName,
                            String keystorePass,
                            String keystorePath,
                            String httpAddr,
                            String cerpath,
                            String encoding) throws Exception {

    //чтение запроса из файла
    InputStream is = null;
    FileOutputStream fost = null;
    final byte[] encodedCert;
    try {
        is = new FileInputStream(reqpath);
        if ("base64".equals(encoding)) {
            //Получение сертификата из запроса, представленного в BASE64 кодировке
            encodedCert =
                    GostCertificateRequest.getEncodedCertFromBASE64(httpAddr, is);
        } else {
            //Получение сертификата из запроса, представленного в DER кодировке
            encodedCert =
                    GostCertificateRequest.getEncodedCertFromDER(httpAddr, is);
        }
        //запись в файл
        fost = new FileOutputStream(cerpath);
        fost.write(encodedCert);

        //запись в хранилище
        final KeyStore ks = KeyStore.getInstance(keystoreName);
        char[] KeyStorePass = null;
        if (!"null".equalsIgnoreCase(keystorePass)) {
            KeyStorePass = keystorePass.toCharArray();
        }
        InputStream Is = null;
        if (!"null".equalsIgnoreCase(keystorePath)) {
            Is = new FileInputStream(keystorePath);
        }
        ks.load(Is, KeyStorePass);

        final CertificateFactory cf = CertificateFactory.getInstance("X509");
        final Certificate cert;
        cert = cf.generateCertificate(new ByteArrayInputStream(encodedCert));
        ks.setCertificateEntry(alias, cert);
        OutputStream os = null;
        if (!"null".equalsIgnoreCase(keystorePath)) {
            os = new FileOutputStream(keystorePath);
        }
        ks.store(os, KeyStorePass);
        log.info(
                "Recording of a certificate to " + cerpath + " and to " +
                        keystoreName + " is completed.");
    } finally {
        if (is != null) is.close();
        if (fost != null) fost.close();
    }


}
}
