/**
 * Copyright 2004-2012 Crypto-Pro. All rights reserved.
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package Crypt_samples;

import ru.CryptoPro.Crypto.Key.GostSecretKey;
import ru.CryptoPro.JCP.Key.SecretKeySpec;
import ru.CryptoPro.JCP.params.CryptParamsSpec;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import java.security.MessageDigest;

/**
 * Небезопасная схема, нерекомендуемая к использованию.
 *
 * 24/08/2012
 *
 */
public class SessionKeyByPasswordExample {

    public static void main(String[] args) throws Exception {

        // Вектор инициализации и данные.
        final byte[] iv = {1, 1, 1, 1, 1, 1, 1, 1};
        final byte[] data = "Simple Text!".getBytes();

        // Пароль клиента хешируем и получаем 32 байта.
        byte[] clientPassword = "password".getBytes();
        byte[] hashedPassword = MessageDigest.getInstance("GOST3411").digest(clientPassword);

        // Создаем сессионный ключ.
        CryptParamsSpec params = CryptParamsSpec.getInstance();
        SecretKeySpec spec = new SecretKeySpec(hashedPassword, params);
        SecretKey skey = new GostSecretKey(spec);

        /*
        KeyStore store = KeyStore.getInstance("HDImageStore");
        store.load(null, null);

        Certificate cert = store.getCertificate("gost_exch");

        KeyFactory skf = KeyFactory.getInstance("GOST28147");
        SecretKey skey = (SecretKey) skf.translateKey(cert.getPublicKey());
        */

        // Шифруем.
        Cipher cipher = Cipher.getInstance("GOST28147");
        cipher.init(Cipher.ENCRYPT_MODE, skey, new IvParameterSpec(iv));
        final byte[] encryptedtext = cipher.doFinal(data, 0, data.length);

        // Расшифруем.
        cipher = Cipher.getInstance("GOST28147");
        cipher.init(Cipher.DECRYPT_MODE, skey, new IvParameterSpec(iv));
        final byte[] decryptedtext = cipher
                .doFinal(encryptedtext, 0, encryptedtext.length);

        // проверка результата.
        if (decryptedtext.length != data.length)
            throw new Exception("Error in crypting");
        for (int i = 0; i < decryptedtext.length; i++)
            if (data[i] != decryptedtext[i])
                throw new Exception("Error in crypting");

        System.out.println("OK");
    }
}
