/**
 * $RCSfileKeyDeletingExample.java,v $
 * version $Revision: 36379 $
 * created 21.08.2017 13:30 by afevma
 * last modified $Date: 2012-05-30 12:19:27 +0400 (Ср, 30 май 2012) $ by $Author: afevma $
 * <p/>
 * Copyright 2004-2017 Crypto-Pro. All rights reserved.
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package ru.CryptoPro.ACSPInClientApp.examples;

import ru.CryptoPro.ACSPInClientApp.interfaces.Executable;
import ru.CryptoPro.ACSPInClientApp.tools.Logger;
import ru.CryptoPro.JCSP.JCSP;

import java.security.KeyStore;

/**
 * Пример KeyDeletingExample предназначен
 * для удаления тестового контейнера.
 *
 * @author Copyright 2004-2017 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class KeyDeletingExample implements Executable<Void> {

    @Override
    public Void execute() throws Exception {

        String alias = KeyGenerationExample.ALIAS;
        Logger.INSTANCE.append("Initializing key store...");

        KeyStore keyStore = KeyStore.getInstance(
            JCSP.HD_STORE_NAME, JCSP.PROVIDER_NAME);

        Logger.INSTANCE.append("Deleting key store " + alias + "...");
        keyStore.load(null, null);

        keyStore.deleteEntry(KeyGenerationExample.ALIAS);
        Logger.INSTANCE.append("Deleting completed.");

        return null;

    }

}
