/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import ru.CryptoPro.JCP.Digest.GostDigest;
import ru.CryptoPro.JCP.params.OID;

import java.security.*;
import java.io.*;
import java.lang.*;

public class Digest32bytes {

    public static void main(String[] args) {
        long startTime = General.printTestName("Digest32bytes");
        try {
            String AlgDigest =  "GOST3411";
            byte [] test_text ={
                0x54,0x68,0x69,0x73,0x20,0x69,0x73,0x20,
                0x6d,0x65,0x73,0x73,0x61,0x67,0x65,0x2c,
                0x20,0x6c,0x65,0x6e,0x67,0x74,0x68,0x3d,
                0x33,0x32,0x20,0x62,0x79,0x74,0x65,0x73,
            };
            byte [] test_result ={
                (byte) 0xb1, (byte) 0xc4, (byte) 0x66, (byte) 0xd3, (byte) 0x75, (byte) 0x19, (byte) 0xb8, (byte) 0x2e,
                (byte) 0x83, (byte) 0x19, (byte) 0x81, (byte) 0x9f, (byte) 0xf3, (byte) 0x25, (byte) 0x95, (byte) 0xe0,
                (byte) 0x47, (byte) 0xa2, (byte) 0x8c, (byte) 0xb6, (byte) 0xf8, (byte) 0x3e, (byte) 0xff, (byte) 0x1c,
                (byte) 0x69, (byte) 0x16, (byte) 0xa8, (byte) 0x15, (byte) 0xa6, (byte) 0x37, (byte) 0xff, (byte) 0xfa,
            };
            MessageDigest sha = MessageDigest.getInstance(AlgDigest);
            ((GostDigest)sha).reset(new OID("1.2.643.2.2.30.0"));
            ByteArrayInputStream stream = new ByteArrayInputStream(test_text);
            DigestInputStream digest  = new DigestInputStream(stream, sha);
            digest.setMessageDigest(sha);
            byte temp[] = new byte[32];
            digest.read(temp, 0, 32);
            sha = digest.getMessageDigest();
            byte[] res = sha.digest();
            if (res.length != 32)
                throw new Exception("The length of digest is invalid");
            for (int i = 0; i<32; i++)
            {
                if (res[i] != test_result[i])
                        throw new Exception("The digest is invalid");
            }
            System.out.println( General.toHexString( res ) );
            General.printOK(startTime);

            }
            catch( Exception ex )
            {
                General.printEx(ex, startTime);
        }
        }
}