/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import ru.CryptoPro.JCP.JCP;
import sun.security.x509.CertAndKeyGen;
import sun.security.x509.X500Name;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.security.*;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

/**
 * В данном примере используется внутренний sun - CertAndKeyGen.
 * Вместо него ремоендуется использовать GostCertificateRequest
 * из состава JCP.
 *
 */
public class General {
    static public String toHexString( byte[] array )
    {
	int i;
	String s = "";
	char hex[] = { '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
	for(i = 0; i < array.length; i++){
	    s += " "+hex[( array[i] >>> 4) & 0xf]+hex[array[i] & 0xf];
    	}
	return s;
    }

    public static byte[] fileRead(String file_name) {
        byte[] res;
        try {
            File file = new File(file_name);
            long len = file.length();
            res = new byte[(int) len];
            InputStream stream = new FileInputStream(file);
            stream.read(res);
            stream.close();
        } catch (IOException ex) {
            res = null;
        }
        return res;
    }

    public static void fileWrite(String file_name, byte[] data) {
        try {
            File file = new File(file_name);
            OutputStream stream = new FileOutputStream(file);
            stream.write(data);
            stream.close();
        } catch (IOException ex) {
        }
    }


    static public void printEx( Exception ex, long startTime)
    {
       long endTime = System.currentTimeMillis();
        try{
            long time = endTime - startTime;
            FileOutputStream stream = null;
            stream = new FileOutputStream("exception.log", true);
            PrintStream printstream = new PrintStream(stream);
            printstream.println("ERROR.");
            ex.printStackTrace(printstream);
            printstream.println();
            printstream.print("The time of execution: ");
            printstream.println(time+" milliseconds");
            printstream.close();
            System.out.println( "ERROR");
            System.out.println(ex.toString());
            System.out.print("The time of execution: ");
            System.out.println(time+" milliseconds");
        }
        catch (FileNotFoundException e)
        {
        }
     }

    static public void printEx( Exception ex, long startTime, long size)
    {
            long endTime = System.currentTimeMillis();
            try{
            long time = endTime - startTime;
            int max = (int) (size/time);
            int min = (int) (size%time);
            FileOutputStream stream = null;
            stream = new FileOutputStream("exception.log", true);
            PrintStream printstream = new PrintStream(stream);
            printstream.println("ERROR.");
            ex.printStackTrace(printstream);
            printstream.println();
            printstream.print("The speed of execution: ");
            printstream.println(max+"."+min+" kb/sec");
            printstream.close();
            System.out.println( "ERROR");
            System.out.println(ex.toString());
            System.out.print("The speed of execution: ");
            System.out.println(max+"."+min+" kb/sec");
        }
        catch (FileNotFoundException e)
        {
        }
     }


    static public long printTestName( String name)
    {
       long startTime = System.currentTimeMillis();
        try{
            FileOutputStream stream = null;
            stream = new FileOutputStream("exception.log", true);
            PrintStream printstream = new PrintStream(stream);
            printstream.print(name + ": ");
            printstream.close();
            System.out.print(name + ": ");
            return startTime;
        }
        catch (FileNotFoundException e)
        {
            return startTime;
        }
 }

     static public void printOK(long startTime)  {
        long endTime = System.currentTimeMillis();
        try{
            long time = endTime - startTime;
            FileOutputStream stream = null;
            stream = new FileOutputStream("exception.log", true);
            PrintStream printstream = new PrintStream(stream);
            printstream.println("OK.");
            printstream.println();
            printstream.print("The time of execution: ");
            printstream.println(time+" milliseconds");
            printstream.close();
            System.out.println("OK.");
            System.out.print("The time of execution: ");
            System.out.println(time+" milliseconds");

    }
        catch (FileNotFoundException e)
        {
        }
 }

   static public void printOK(long startTime, int size)  {
         long endTime = System.currentTimeMillis();
        try{
            long time = endTime - startTime;
            int max = (int) (size/time);
            int min = (int) (size%time);
            FileOutputStream stream = null;
            stream = new FileOutputStream("exception.log", true);
            PrintStream printstream = new PrintStream(stream);
            printstream.println("OK.");
            printstream.println();
            printstream.print("The speed of execution: ");
            printstream.println(max+"."+min+" kb/sec");
            printstream.close();
            System.out.println("OK.");
            System.out.print("The speed of execution: ");
            System.out.println(max+"."+min+" kb/sec");


    }
        catch (FileNotFoundException e)
        {
        }
 }

  public static KeyPair KeyPairGen (String AlgKeyPair, int keysize) throws
          NoSuchAlgorithmException{
 		    KeyPairGenerator keyGen = KeyPairGenerator.getInstance(AlgKeyPair);
		    keyGen.initialize(keysize);
		    KeyPair pair = keyGen.generateKeyPair();
            return pair;
  }

  static public X500Name get_500_name() throws IOException {
            String commonName = "Elvira";
            String organizationalUnit = "Unknown";
            String organization = "CryptoPro";
            String city = "Moscow";
            String state = "Unknown";
            String country = "RU";
            X500Name name = new X500Name(commonName, organizationalUnit, organization, city, state, country);
            return name;
    }

public static void SetStoreEntry(String AlgKey, String AlgSign, int keysize, int validity,
                                 String alias, String password, String certfilename)
        throws NoSuchAlgorithmException, InvalidKeyException, FileNotFoundException, IOException,
        NoSuchProviderException, SignatureException, CertificateException, KeyStoreException {

 // generate
        CertAndKeyGen keypair;
        keypair = new CertAndKeyGen(AlgKey, AlgSign);
        keypair.generate(keysize);
        PrivateKey privKey = keypair.getPrivateKey();
        X509Certificate[] chain = new X509Certificate[1];
        chain[0] = keypair.getSelfCertificate(get_500_name(), validity*24*60*60);

// write certificate
        File cert_file = new File(certfilename);
        OutputStream cert_Stream;
        cert_Stream = new FileOutputStream(cert_file);
        cert_Stream.write(chain[0].getEncoded());
// store
        KeyStore keyStore = General.LoadKeyStore(password);
        keyStore.setKeyEntry(alias, privKey, password.toCharArray(), chain);
        General.SaveKeyStore(keyStore, password);
    }

public static KeyStore LoadKeyStore(String password)
        throws KeyStoreException, NoSuchAlgorithmException, CertificateException, IOException {
        KeyStore keyStore = KeyStore.getInstance(JCP.HD_STORE_NAME);
            try{
                String ksfname = System.getProperty("user.home") + File.separator + ".keystore";
                File ksfile = new File(ksfname);
                InputStream ksStream = new FileInputStream(ksfile);
                keyStore.load(ksStream, password.toCharArray());
                ksStream.close();
                return keyStore;
            }
            catch (FileNotFoundException e) {
                keyStore.load(null, null);
                return keyStore;
            }
}


    public static void SaveKeyStore(KeyStore keyStore, String password)
            throws NoSuchAlgorithmException, IOException, CertificateException, KeyStoreException {
            String ksfname = System.getProperty("user.home") + File.separator + ".keystore";
            File ksfile = new File(ksfname);
            OutputStream ksStream = new FileOutputStream(ksfile);
            keyStore.store(ksStream, password.toCharArray());
            ksStream.close();
     }


public static PublicKey GetPublicFromStore(KeyStore keyStore, String alias)
        throws KeyStoreException {
        java.security.cert.Certificate cert = keyStore.getCertificate(alias);
        PublicKey pubKey = cert.getPublicKey();
        return pubKey;
  }

public static PrivateKey GetPrivateFromStore(KeyStore keyStore, String alias, String password)
        throws NoSuchAlgorithmException, KeyStoreException,
        UnrecoverableKeyException {
        Key key = keyStore.getKey(alias, password.toCharArray());
        PrivateKey privKey = (PrivateKey)key;
        return privKey;
 }


}