/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import ru.CryptoPro.JCP.JCP;


import java.security.KeyPair;
import java.security.PublicKey;
import java.security.PrivateKey;

public class KeyPairGen {

    public static void main(String[] args) {
        main_(JCP.GOST_EL_DEGREE_NAME, 512);
        main_(JCP.GOST_EL_2012_256_NAME, 512);
        main_(JCP.GOST_EL_2012_512_NAME, 1024);
    }

    /**
     * Генерация ключевой пары.
     *
     * @param AlgKeyPair Алгоритм ключа.
     */
    public static void main_(String AlgKeyPair, int keysize) {

        long startTime = General.printTestName("KeyPairGen_" + AlgKeyPair);

        try {
            KeyPair pair = General.KeyPairGen(AlgKeyPair, keysize);
            PublicKey pub = pair.getPublic();
            PrivateKey priv = pair.getPrivate();
            General.printOK(startTime);
	    } catch(Exception ex) {
		  General.printEx(ex, startTime);
	    }
    }

}