/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import ru.CryptoPro.JCP.JCP;

import java.security.*;
import java.io.*;
import java.lang.*;

public class Sign{
public static final String text = "Example of generating and verifing signature.";
      public static void main(String[] args) {
          long startTime = General.printTestName("Sign");
          try {
              String AlgKeyPair = JCP.GOST_EL_DEGREE_NAME;
              String AlgSign = JCP.CRYPTOPRO_SIGN_NAME;
              String fileparam = "pubKeyParam.bin";
              String filesign = "signature.txt";
              int keysize = 512;
              KeyPair pair = General.KeyPairGen(AlgKeyPair, keysize);
              Signature sig = Signature.getInstance(AlgSign);
              PrivateKey priv = pair.getPrivate();
              PublicKey pub = pair.getPublic();
              byte[] param = pub.getEncoded();
              FileOutputStream pubKeyParam = new FileOutputStream(fileparam);
              DataOutputStream data_stream = new DataOutputStream( pubKeyParam );
              data_stream.writeInt(param.length);
              data_stream.write(param);
              sig.initSign(priv);
              byte src[]  = text.getBytes();
              sig.update(src);
              byte[] signature = sig.sign();
              System.out.println( General.toHexString( signature ) );
              General.fileWrite(filesign, signature);
              General.printOK(startTime);
          }
          catch( Exception ex )
          {
                   General.printEx(ex, startTime);
          }
      }
}