/**
 * Copyright 2004-2012 Crypto-Pro. All rights reserved.
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package userSamples.ca15;

/**
 * Класс Configuration описывает параметры пользователя:
 * его имя (COMMON_NAME) и страну (COUNTRY_NAME), которые использовались при
 * регистрации и которые нужны при генерации запрос на сертификат;
 * его tokenID и password, полученные при регистрации и соответствующие
 * имени пользователя.
 *
 * $$ Для УЦ 1.5 $$
 * Предполагается, что данные пользователь уже зарегистрирован, потому рекомендуется
 * запускать примеры в таком порядке:
 * 1) GetRootCertificateExample - получение списка корневых сертификатов УЦ;
 * 2) RegisterUserExample - регистрация пользователя с именем COMMON_NAME и COUNTRY_NAME
 * и получение tokenID и password, которые следует сохранить в конфигурации;
 * 3) SendRequestAndGetCertificateExample - отправка запроса на сертификат с параметрами
 * COMMON_NAME и COUNTRY_NAME от имени пользователя tokenID и password и получение сертификата;
 * 4) GetUserCertificateRequestListExample - получение списка запросов на сертификаты
 * зарегистрированного пользователя tokenID и password.
 *
 * 12/11/2012
 *
 */
public interface Configuration {

    /**
     * Адрес УЦ (CA15).
     */
    public static final String CA15_ADDRESS_HTTP = "http://www.cryptopro.ru/ui";

    /**
     * Адрес УЦ (CA15).
     */
    public static final String CA15_ADDRESS_HTTPS = "https://www.cryptopro.ru/ui";

    /**
     * Адрес УЦ (CA20).
     * TODO заменить адрес.
     */
    // JCP-387: пока нет внещнего тестового УЦ 2.0 - заблокировано (адрес не указан)!
    public static final String CA20_ADDRESS = "";

    /**
     * Поле CN (CommonName) (CA15).
     */
    // TODO заменить имя.
    public static final String COMMON_NAME = "afevma_555";
    /**
     * Поле C (CountryName) (CA15).
     */
    public static final String COUNTRY_NAME = "RU";
    /**
     * Маркер зарегистрированного пользователя (CA15).
     */
    // TODO заменить маркер.
    public static final String TOKEN_ID = "18786";
    /**
     * Пароль зарегистрированного пользователя (CA15).
     */
    // TODO заменить пароль.
    public static final String PASSWORD = "xq5rvr22";

    /**
     * Папка пользователя УЦ (CA20).
     * TODO заменить папку.
     */
    public static final String CS20_USER_FOLDER = "MainRA";

}
